require 'sketchup.rb' 
module IT_TL
def self.ithil_translit
model = Sketchup.active_model
selection = model.active_entities
		model.start_operation("Translit",true)
		puts "Using enhanced speed mode"
Sketchup.set_status_text "Program is running..."
model.start_operation("Translit")
model.pages.each { |m| m.name = self.russian_translit(m.name)}
model.layers.each { |m| m.name = self.russian_translit(m.name)}
model.materials.each { |m| m.name = self.russian_translit(m.name)
if m.respond_to?(:texture) 
			self.ithil_translit_save_diffuse (m) 
			self.ithil_translit_load_diffuse (m)
		 
end #if 
 }

model.definitions.each { |m| m.name = self.russian_translit(m.name) }
self.process_at_level_translit selection, {}
Sketchup.set_status_text "Done!"
model.commit_operation
  end#def

 def self.process_at_level_translit(entities, hcomp)
 
	entities.each do |entity| 
		case entity.typename
		when 'Group'
			entity.name= self.russian_translit(entity.name)
			self.process_at_level_translit entity.entities, hcomp
		when 'ComponentInstance'
			edef = entity.definition
			next if hcomp[edef.to_s]
			hcomp[edef.to_s] = edef
			self.process_at_level_translit edef.entities, hcomp
		end
	end
end #process_at_level_translit

def self.translit_tex_name (material)

end #translit_tex_name

def self.material_test (material)
	model = Sketchup.active_model
	if material == nil
		UI.messagebox("Please, select any material!")
		return 
	end# if
	unless model.materials.include?( material )
		UI.messagebox( "Select a material already in the model. Not from the libraries." )
		return
	end
end #material_test

def self.ithil_translit_save_diffuse (material)
	IT_TL.material_test (material)
if (material.respond_to?(:texture))
@@translit_copy_texture_use = material.texture
else 
@@translit_copy_texture_use = nil
@@translit_copy_texture = nil
end if

if (material.respond_to?(:alpha))
@@translit_copy_alpha = material.alpha
end


@@translit_copy_color_red = material.color.red
@@translit_copy_color_green = material.color.green
@@translit_copy_color_blue = material.color.blue

if @@translit_copy_texture_use
rashir = ".jpg"
texture_filename = @@translit_copy_texture_use.filename

if texture_filename.downcase.include? ".jpeg" then rashir = ".jpg" ;end
if texture_filename.downcase.include? ".png" then rashir = ".png" ;end
if texture_filename.downcase.include? ".tif" then rashir = ".tif" ;end
if texture_filename.downcase.include? ".psd" then rashir = ".psd" ;end
if texture_filename.downcase.include? ".tga" then rashir = ".tga" ;end
if texture_filename.downcase.include? ".bmp" then rashir = ".bmp" ;end

	file_name="/"+self.russian_translit(material.display_name)+rashir
	model = Sketchup.active_model
  path=model.path
  if not path or path==""
    name="Untitled"
    output=File.join(Dir.pwd,name).tr("\\","/")
  else
    name=model.title
    output=File.join(File.dirname(path),name).tr("\\","/")
  end
@@translit_copy_texture = output+file_name
@@translit_copy_texture_width = material.texture.width
@@translit_copy_texture_height = material.texture.height
Dir.mkdir(output) unless File.exist?(output)

  ###
  group=model.entities.add_group
  tw = Sketchup.create_texture_writer


    if material.texture
      group.material= material
      tw.load(group, true)
    end

 tw.write(group, @@translit_copy_texture, true) 
  group.erase! if group.valid?
  puts "Exported Textures into Folder:\n"+output
  puts @@translit_copy_texture
end 
	

end #ithil_translit_save_diffuse

def self.ithil_translit_load_diffuse (material)
					material.alpha = @@translit_copy_alpha
	 if @@translit_copy_texture_use
						material.texture=@@translit_copy_texture
						material.texture.size=[@@translit_copy_texture_width,@@translit_copy_texture_height]
			puts "Texture"
	else material.texture = nil
		material.color = Sketchup::Color.new((@@translit_copy_color_red),( @@translit_copy_color_green),(@@translit_copy_color_blue))
		puts "Color solid"
	end # if
end # def ithil_translit_load_diffuse

def self.russian_translit(text)
    translited = text.tr(' абвгдеёзийклмнопрстуфхэыьъ', '_abvgdeezijklmnoprstufhey\'\'')
													   
    translited = translited.tr('АБВГДЕЁЗИЙКЛМНОПРСТУФХЭЫЬЪ', 'ABVGDEEZIJKLMNOPRSTUFHEYY\'\'\'')

    translited = translited.gsub(/[жцчшщъюяЖЦЧШЩЪЮЯ]/,
        'ж' => 'zh', 'ц' => 'ts', 'ч' => 'ch', 'ш' => 'sh', 'щ' => 'sch', 'ъ' => '', 'ю' => 'ju', 'я' => 'ja',
        'Ж' => 'ZH', 'Ц' => 'TS', 'Ч' => 'CH', 'Ш' => 'SH', 'Щ' => 'SCH', 'Ъ' => '', 'Ю' => 'JU', 'Я' => 'JA')
    return translited
end
end #module IR
		plugins = Sketchup.find_support_file("Plugins")
		folder="ithil_tools"
		icon_translit = File.join(plugins,folder, "translit_l.png")
		icon_s_translit = File.join(plugins,folder, "translit_s.png")

		
It_tb = UI::Toolbar.new("Translit")

		ith_translit = UI::Command.new("Ithil Translit"){IT_TL.ithil_translit}
		ith_translit.small_icon = icon_s_translit
		ith_translit.large_icon = icon_translit
		ith_translit.tooltip = "Translit Layers, Materials, Group, Scene and Component"
		ith_translit.status_bar_text = "Transliterate Cyrillic letters to represent them in Latin characters"

It_tb.add_item(ith_translit)
It_tb.show

if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("Rename Material"){IT_TL.ithil_translit}
		end
else
	if !file_loaded?('ithil_menu_loader') then
		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
		$ithil_menu.add_item("Translit"){IT_TL.ithil_translit}

	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)